using System;
using System.Collections.Generic;
using System.Data;
using Blog.Modelo;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace Blog.AcessoADados
{
    public class ErrosDAO : DAO
    {
        public IList<Erro> ObterTodos()
        {
            try
            {
                var erros = new List<Erro>();
                var db = DatabaseFactory.CreateDatabase("Posts");
                var reader = db.ExecuteReader(CommandType.Text,
                                              @"SELECT        LogID, Timestamp, MachineName, Message
                  FROM          Log
                  ORDER BY      LogID DESC"
                    );
                while (reader.Read())
                {
                    var erro = new Erro
                                   {
                                       Id = reader.GetInt32(0),
                                       Timestamp = reader.GetDateTime(1),
                                       MachineName = reader.GetString(2),
                                       Message = reader.GetString(3)
                                   };
                    erros.Add(erro);
                }
                reader.Close();
                return erros;
            }
            catch (Exception ex)
            {
                LogarErro(ex);
                return null;
            }
        }
    }
}