﻿using System;
using System.Web.Mvc;
using Blog.AcessoADados;

namespace Blog.WebApp.Controllers
{
    [HandleError]
    public class HomeController : ControladorBase
    {
        public ActionResult Index(int? id)
        {
            try
            {
                var paginacao = default(Paginacao);
                if (id.HasValue)
                {
                    paginacao = new Paginacao
                    {
                        NumeroDaPagina = id.Value,
                        QuantidadePorPagina = 5
                    };
                }

                var postsDAO = new PostsDAO("Posts");
                var posts = postsDAO.ObterTodos(Contexto.UsuarioLogado, paginacao);
                return View(posts);
            }
            catch (Exception ex)
            {
                LogarErro(ex);
                throw;
            }           
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
