﻿using System.Web.Mvc;
using System.Web.Routing;
using Blog.Modelo;

namespace Blog.WebApp
{
    public class MvcApplication : System.Web.HttpApplication
    {

        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);

            ConfigurarUsuario();
        }

        private void ConfigurarUsuario()
        {
            //em um sistema real validariamos o usuário, e obteríamos seu perfil via um repositório
            Contexto.UsuarioLogado = new Usuario
                                         {
                                             Nome = "Giovanni Bassi",
                                             Email = "giggio@giggio.net",
                                             Id = 2
                                         };
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Post", // Route name
                "Post/{titulo}", // URL with parameters
                new { controller = "Posts", action = "Post", titulo = "" } // Parameter defaults
                );

            routes.MapRoute(
                "Default",                                              // Route name
                "{controller}/{action}/{id}",                           // URL with parameters
                new { controller = "Home", action = "Index", id = "" }  // Parameter defaults
            );

        }

        protected void Application_BeginRequest()
        {
            ConfigurarGlobalizacao();
        }
        private void ConfigurarGlobalizacao()
        {
            var ptbr = new System.Globalization.CultureInfo("pt-BR");
            System.Threading.Thread.CurrentThread.CurrentCulture = ptbr;
            System.Threading.Thread.CurrentThread.CurrentUICulture = ptbr;
        }

    }
}