﻿using System;
using System.Web.Mvc;

namespace Blog.WebApp.Helpers
{
    public static class HelpersGenericos
    {
        public static string Comentarios(this long numeroDeComentarios)
        {
            string texto;
            if (numeroDeComentarios < 0)
                throw new ArgumentException("numeroDeComentarios");
            else switch (numeroDeComentarios)
                {
                    case 0:
                        texto = "Nenhum comentário";
                        break;
                    case 1:
                        texto = "Um comentário";
                        break;
                    default:
                        texto = numeroDeComentarios.ToString() + " comentários";
                        break;
                }
            return texto;
        }
        public static string Comentarios(this int numeroDeComentarios)
        {
            return Comentarios((long)numeroDeComentarios);
        }
        public static string LinkSimples<T>(this HtmlHelper<T> html, string text, string url, string target) where T : class
        {
            var link = string.Format("<a href=\"{0}\"", url);
            if (!string.IsNullOrEmpty(target))
                link += string.Format(" target=\"{0}\"", target);
            link += ">" + text + "</a>";
            return link;
        }

        public static string PostLink<T>(this HtmlHelper<T> html, string actionName, string textoLink, object routeValues) where T : class
        {
            var url = new UrlHelper(html.ViewContext.RequestContext, html.RouteCollection);
            var acao = url.Action(actionName, routeValues);
            var link = string.Format
                (@"
<form id=""{0}"" action=""{1}"" method=""post"" style=""display:inline;"">
    <a href=""#"" onclick=""javascript:document.getElementById('{0}').submit();return false;"">{2}</a>
</form>",
                "a" + Guid.NewGuid().ToString().Replace("_", ""),
                acao,
                textoLink);
            return link;
        }

    }
}
