using System;
using System.Diagnostics;

namespace Blog.WebApp.Servicos
{
    public abstract class Interessado
    {
        public abstract void Notificar(string textoNotificacao);

        public virtual string Email { get; set; }
        public virtual string Nome { get; set; }
    }

    class InteressadoPorEmail : Interessado
    {
        public override void Notificar(string textoNotificacao)
        {
            Debug.WriteLine(string.Format(
                                "Email enviado para usurio {0}.\nEndereo:\n{1}\nCorpo da mensagem:\n{2}",
                                Nome,
                                Email,
                                textoNotificacao));

        }
    }

    class InteressadoRSS : Interessado
    {
        public override string Email
        {
            get { throw new InvalidOperationException(); }
            set { throw new InvalidOperationException(); }
        }

        public override string Nome
        {
            get { throw new InvalidOperationException(); }
            set { throw new InvalidOperationException(); }
        }

        public string Endereco { get; set; }

        public override void Notificar(string textoNotificacao)
        {
            Debug.WriteLine(string.Format(
                                "Publicado via rss. Notificao:\n{0}",
                                textoNotificacao));
        }
    }
}