using System.Collections.Generic;
using System.Diagnostics;
using Blog.Modelo;

namespace Blog.WebApp.Servicos
{
    public class Notificador
    {
        public void AvisarDoComentario(Comentario comentario)
        {
            var textoNotificacao = string.Format(
                "O seu post {0} acaba de ser comentado por {1} <{2}>. Texto do comentrio:\n{3}",
                comentario.Post.Titulo,
                comentario.Comentarista.Nome,
                comentario.Comentarista.Email,
                comentario.Corpo);
            var interessados = ObterInteressados();
            foreach (var interessado in interessados)
            {
                interessado.Notificar(textoNotificacao);
                Debug.WriteLine(string.Format(
                                    "Interessado \"{0}\" <{1}> notificado.",
                                    interessado.Nome,
                                    interessado.Email));
            }

        }

        public IEnumerable<Interessado> ObterInteressados()
        {
            return new List<Interessado>()
                       {
                           new InteressadoPorEmail
                               {
                                   Email = "giggio@giggio.net",
                                   Nome = "Giovanni Bassi"
                               },
                           new InteressadoPorEmail
                               {
                                   Email = "victor@cavalcante.net",
                                   Nome = "Victor Cavalcante"
                               },

                       #region " Outro Interessado "
                           new InteressadoRSS{Endereco = "http://meurss.com/rss"}
	                   #endregion

                       };
        }

    }
}